{ varianta 1 }
{ unul in dreapta, celalalt in stanga }

uses graph,crt;
type
    punct=
          record
                x,y:real;
          end;
    vector=array[1..500] of punct;

const
     xmax:longint=10000;
     ymax:longint=15500;
     depl:longint=7000;
     raza:real=10000;
     cx:longint=15000;
     cy:longint=15000;

var
   c,d:vector;
   st:array[1..500] of integer;
   f:text;
   i,k,n,nc,nd:integer;
   r:real;


{procedure qsort(l,r:integer);
var
  i,j,x,y:integer;
  aux:punct;
begin
  i:=l;j:=r;
  x:=a[(l+r) div 2].x;
  y:=a[(l+r) div 2].y;
  repeat
        while (a[i].y<y) or (a[i].y=y) and (a[i].x<x) do
              inc(i);
        while (a[j].y>y) or (a[j].y=y) and (a[j].x>x) do
              dec(j);
        if i<=j
           then
               begin
                    aux:=a[i];
                    a[i]:=a[j];
                    a[j]:=aux;
                    inc(i);
                    dec(j);
               end;
  until i>j;
  if l<j
     then qsort(l,j);
  if i<r
     then qsort(i,r);
end;}

procedure sortare;
var
   index:boolean;
   aux:punct;
begin
     index:=true;
     while index do
           begin
                index:=false;
                for i:=1 to nc-1 do
                    if (c[i].y>c[i+1].y) or (c[i].y=c[i+1].y) and (c[i].x>c[i+1].x)
                       then
                           begin
                                aux:=c[i];
                                c[i]:=c[i+1];
                                c[i+1]:=aux;
                                index:=true;
                           end;
           end;
end;

procedure qsort(l,r:integer);
var
  i,j:integer;
  x,y:real;
  aux:punct;
begin
  i:=l;j:=r;
  x:=c[(l+r) div 2].x;
  y:=c[(l+r) div 2].y;
  repeat
        while (c[i].y<y) or (c[i].y=y) and (c[i].x<x) do
              inc(i);
        while (c[j].y>y) or (c[j].y=y) and (c[j].x>x) do
              dec(j);
        if i<=j
           then
               begin
                    aux:=c[i];
                    c[i]:=c[j];
                    c[j]:=aux;
                    inc(i);
                    dec(j);
               end;
  until i>j;
  if l<j
     then qsort(l,j);
  if i<r
     then qsort(i,r);
end;

{function semn(p1,p2,p3:punct):boolean;
var
   a,b,c:real;
begin
     a:=p1.y-p2.y;
     b:=p2.x-p1.x;
     c:=p1.x*p2.y-p2.x*p1.y;

     if a*p3.x+b*p3.y+c<=0
        then semn:=true
        else semn:=false;
end;}

function semn(p,p1,p2:punct):char;
var s:real;
begin
     s:=(p.x-p1.x)*(p2.y-p1.y)-(p.y-p1.y)*(p2.x-p1.x);
     if abs(s)<0.000001 then semn:='0'
     else if s<0 then semn:='-'
          else semn:='+'
end;


procedure poligon;
var i,k:integer; e:boolean;
begin
{     qsort(1,nc);}
     sortare;
     d[1]:=c[1];
     nd:=1;
     repeat
        for i:=1 to nc do
            if (c[i].x<>d[nd].x)or(c[i].y<>d[nd].y) then begin
            e:=true;
            for k:=1 to nc do
                if not (semn(c[k],d[nd],c[i]) in ['+','0']) then e:=false;
            if e then begin inc(nd);d[nd]:=c[i];break end
        end
     until (d[nd].x=d[1].x)and(d[nd].y=d[1].y);
     nd:=nd-1;
end;

{procedure acoperire;
var
   i,j,ss:integer;
   v:array[1..500] of boolean;
begin
     qsort(1,n);
     fillchar(v,sizeof(v),false);
     k:=1;
     i:=2;
     ss:=1;
     st[1]:=1;
     while (i>=1) do
           begin
                while v[i] do
                      i:=i+ss;
                if i=n
                   then ss:=-1;
                while (k>1) and semn(a[st[k-1]],a[st[k]],a[i]) do
                      begin
                           v[st[k]]:=false;
                           dec(k);
                      end;
                inc(k);
                st[k]:=i;
                v[i]:=true;
                if i=1
                   then break;
           end;
end;}

begin
     nc:=100;
     randomize;
     for i:=1 to nc do
         begin
              r:=raza-random(1);
              c[i].x:=cx+trunc(r*cos(2*pi/nc*i));
              c[i].y:=cy+trunc(r*sin(2*pi/nc*i));
         end;

{     assign(f,'poligon.in');
     reset(f);
     readln(f,n);
     for i:=1 to n do
         readln(f,a[i].x,a[i].y);
     close(f);}
     c[nc div 2].x:=20000;
     c[nc div 2].y:=-15000;
     c[nc div 2-1].x:=16000;
     c[nc div 2-1].y:=-25000;
{     acoperire;}
     poligon;
     assign(f,'poligon.in');
     rewrite(f);
     writeln(f,'-30000 30000');
     writeln(f,'30000 -30000');
     writeln(f,nd);
     for i:=1 to nd do
         writeln(f,d[i].x:0:0,' ',d[i].y:0:0);

     nc:=100;
     for i:=1 to nc do
         begin
              r:=raza-random(1);
              c[i].x:=-cx+trunc(r*cos(2*pi/nc*i));
              c[i].y:=-cy+trunc(r*sin(2*pi/nc*i));
         end;

     c[nc div 2].x:=-20000;
     c[nc div 2].y:=15000;
     c[nc div 2-1].x:=-16000;
     c[nc div 2-1].y:=25000;

{     acoperire;}
     poligon;
     writeln(f,nd);
     for i:=1 to nd do
         writeln(f,d[i].x:0:0,' ',d[i].y:0:0);
     close(f);
end.